## firebird4.0 4.0.5.3140.ds6

=== CMakeLists.txt ===
#
# firebird (trunk)
#
#  This file has following organization:
#  1. cmake settings
#  2. project settings
#  3. packages
#  4. configure
#  5. compiler & linker settings
#  6. pre-build
#  7. build
#

################################################################################
#
# cmake settings
#
################################################################################

cmake_minimum_required(VERSION 2.8.12)

# In-source builds are not possible and so disabled.
if (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
    message(FATAL_ERROR
        "CMake generation for Firebird is not possible within the source directory!"
        "\n Remove the CMakeCache.txt file and try again from another folder, e.g.:"
        "\n "
        "\n rm CMakeCache.txt"
        "\n mkdir build"
        "\n cd build"
        "\n cmake .."
    )
endif()

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/builds/cmake)

if (NATIVE_BUILD_DIR)
    get_filename_component(NATIVE_BUILD_DIR ${NATIVE_BUILD_DIR} ABSOLUTE)
else()
    set(NATIVE_BUILD_DIR ${CMAKE_BINARY_DIR})
endif()

# Use solution folders.
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set_property(GLOBAL PROPERTY PREDEFINED_TARGETS_FOLDER "CMake Targets")

################################################################################
#
# project settings
#
################################################################################

project("firebird" C CXX)

########################################
# build type settings
########################################

# Define build mode
if (NOT DEFINED CMAKE_BUILD_TYPE OR "${CMAKE_BUILD_TYPE}" STREQUAL "")
    set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build.")
endif()

# Qt with MSVC does not have multiconfiguration option by default,
#  so we create it.
set(DEFAULT_CONFIGURATION)

# Set build types if none was specified
if (NOT DEFINED CMAKE_CONFIGURATION_TYPES)
    set(CMAKE_CONFIGURATION_TYPES Debug Release MinSizeRel RelWithDebInfo)
    set(DEFAULT_CONFIGURATION ${CMAKE_BUILD_TYPE})
endif()

########################################
# Output directory settings
########################################

set(output_dir ${CMAKE_BINARY_DIR}/${PROJECT_NAME})
set(boot_dir ${CMAKE_BINARY_DIR}/src)

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${output_dir})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${output_dir})

if (MSVC OR XCODE)
    set(output_dir ${output_dir}/$<CONFIG>)
    set(boot_dir ${boot_dir}/$<CONFIG>)
endif()

if (MSVC AND DEFAULT_CONFIGURATION)
    foreach(conf ${CMAKE_CONFIGURATION_TYPES})
        string(TOUPPER ${conf} conf2)
        set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${conf2} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${DEFAULT_CONFIGURATION})
    endforeach()
endif()

if (XCODE)
    foreach(conf ${CMAKE_CONFIGURATION_TYPES})
        string(TOUPPER ${conf} conf2)
        set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${conf2} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${conf}/bin)
    endforeach()
elseif (UNIX)
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${output_dir}/bin)
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${output_dir}/bin)
endif()

################################################################################
#
# packages
#
################################################################################

########################################
# icu
########################################

if (UNIX)
    if (NOT ICU_INCLUDE_DIR)
        find_path(ICU_INCLUDE_DIR unicode/ucnv.h
            PATHS
                /usr/include
                /usr/include/x86_64-linux-gnu
                /usr/local/include
                /opt/local/include
                /usr/local/opt/icu4c/include
            CMAKE_FIND_ROOT_PATH_BOTH
        )
        if ("${ICU_INCLUDE_DIR}" STREQUAL "ICU_INCLUDE_DIR-NOTFOUND")
            message(FATAL_ERROR "ICU headers not found!")
        endif()
    endif()
    if (CMAKE_CROSSCOMPILING)
        execute_process(COMMAND ${CMAKE_COMMAND} -E copy_directory
            ${ICU_INCLUDE_DIR}/unicode
            ${CMAKE_BINARY_DIR}/unicode
        )
        set(ICU_INCLUDE_DIR ${CMAKE_BINARY_DIR})
    endif()
    set(ICU_INCLUDE_DIRS ${ICU_INCLUDE_DIR})
    include_directories(${ICU_INCLUDE_DIRS})
endif()

################################################################################
#
# configure
#
################################################################################

include(Configure)

if (FREEBSD)
    # temporary
    set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR})
endif()

set(FB_PREFIX ${CMAKE_INSTALL_PREFIX}/${PROJECT_NAME})
set(FB_IPC_NAME "FirebirdIPI")
set(FB_LOGFILENAME "firebird.log")
set(FB_PIPE_NAME "interbas")
set(FB_SERVICE_NAME "gds_db")
set(FB_SERVICE_PORT 3050)

if (WIN32)
    set(FB_PREFIX "c:\\\\Program Files\\\\Firebird\\\\")
    set(FB_IPC_NAME "FIREBIRD")
endif()

set(AUTOCONFIG_SRC ${CMAKE_SOURCE_DIR}/src/include/gen/autoconfig.h.in)
set(AUTOCONFIG ${CMAKE_BINARY_DIR}/src/include/gen/autoconfig.h)
configure_file(${AUTOCONFIG_SRC} ${AUTOCONFIG} @ONLY)

################################################################################
#
# compiler & linker settings
#
################################################################################

add_definitions(-DDEV_BUILD)

if (WIN32)
    set(OS_DIR win32)
    set(VERSION_RC ${CMAKE_SOURCE_DIR}/src/jrd/version.rc)

    if (MSVC)
        set(disable_msvc_warnings "/wd4996")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /MP ${disable_msvc_warnings}")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP ${disable_msvc_warnings}")

        if (MSVC_STATIC_RUNTIME)
            set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} /MTd")
            set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /MT")
            set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
            set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
        endif()
    endif(MSVC)

    set(LIB_Ws2_32 Ws2_32)
    set(LIB_comctl32 comctl32)
    set(LIB_mpr mpr)
    set(LIB_version version)
endif(WIN32)

if (MINGW)
    # clear unix-style prefixes
    set(CMAKE_SHARED_LIBRARY_PREFIX)
    set(CMAKE_SHARED_MODULE_PREFIX)
    set(CMAKE_STATIC_LIBRARY_PREFIX)

    add_definitions(-D_WIN32_WINNT=0x0600)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4 -std=c++11")
endif()

if (UNIX)
    set(OS_DIR posix)

    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -msse4 -std=c++11")

    if (NOT CMAKE_CROSSCOMPILING)
        set(LIB_readline readline)
    endif()
    if (NOT FREEBSD)
        set(LIB_dl dl)
    endif()
endif()

if (NOT LINUX AND (CLANG OR IOS))
    set(LIB_iconv iconv)
endif()

if (FREEBSD OR APPLE)
    include_directories(/usr/local/include)
    link_directories(/usr/local/lib)
endif()

if (APPLE)
    set(OS_DIR darwin)

    if (NOT CMAKE_CROSSCOMPILING)
        include_directories(/opt/local/include)
        link_directories(/opt/local/lib)
        link_directories(/usr/local/opt/icu4c/lib)
    endif()

    find_library(LIB_CoreFoundation CoreFoundation)
elseif (UNIX)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pthread")
endif()

################################################################################
#
# pre-build
#
################################################################################

if (WIN32)
    # icu
    if (NOT ICU_EXTRACT)
        message(STATUS "Extracting pre-built ICU")
        set(ICU_EXTRACT ${CMAKE_CURRENT_SOURCE_DIR}/extern/icu/icu.exe -y
            CACHE STRING "ICU extraction variable")
        execute_process(COMMAND ${ICU_EXTRACT})
    endif()

	# determine icu version
	foreach(v RANGE 63 83)
		if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/extern/icu/icudt${v}l.dat)
			set(ICU_VERSION ${v} CACHE STRING "ICU version")
		endif()
	endforeach()

    # zlib
    if (NOT ZLIB_EXTRACT)
        message(STATUS "Extracting pre-built zlib")
        set(ZLIB_EXTRACT ${CMAKE_CURRENT_SOURCE_DIR}/extern/zlib/zlib.exe -y
            CACHE STRING "zlib extraction variable")
        execute_process(COMMAND ${ZLIB_EXTRACT})
    endif()
endif()

if (UNIX)
    file(GLOB vers_src "${CMAKE_SOURCE_DIR}/builds/posix/*.vers")
    foreach(f ${vers_src})
        get_filename_component(name ${f} NAME)
        set(name ${CMAKE_BINARY_DIR}/builds/posix/${name})

        if (AIX)
            file(WRITE ${name} "#!\n")
        elseif (LINUX)
            file(WRITE ${name} "{\nglobal:\n")
        endif()

        file(STRINGS ${f} strings)
        foreach(s ${strings})
            string(REGEX REPLACE "#.*$" "" s "${s}")
            string(STRIP "${s}" s)
            if (NOT "${s}" STREQUAL "")
                if (AIX)
                    file(APPEND ${name} "\t${s}\n")
                elseif (APPLE)
                    file(APPEND ${name} "\t_${s}\n")
                elseif (HPUX)
                    file(APPEND ${name} "+e ${s}\n")
                else()
                    file(APPEND ${name} "\t${s};\n")
                endif()
            endif()
        endforeach()

        if (LINUX)
            file(APPEND ${name} "local:\n\t*;\n};\n")
        endif()
    endforeach()
endif()

################################################################################
#
# build
#
################################################################################

include(BuildFunctions)

if (NOT CMAKE_CROSSCOMPILING)

create_boot_commands()
create_master_commands()

endif() # if (NOT CMAKE_CROSSCOMPILING)

crosscompile_prebuild_steps()

include_directories("extern/libtommath")
include_directories("extern/libtomcrypt/src/headers")
include_directories("extern/decNumber")
include_directories("extern/icu/include")
include_directories("extern/zlib")

include_directories("src/include")
include_directories("src/include/gen")
include_directories("${CMAKE_CURRENT_BINARY_DIR}/src/include")
include_directories("${CMAKE_CURRENT_BINARY_DIR}/src/include/gen")

########################################
# LIBRARY libtommath
########################################

file(GLOB libtommath_src "extern/libtommath/*.c" "extern/libtommath/*.h")

add_library             (libtommath ${libtommath_src})
project_group           (libtommath Extern)


########################################
# LIBRARY libtomcrypt
########################################

file(GLOB_RECURSE libtomcrypt_src "extern/libtomcrypt/src/*")
list(FILTER libtomcrypt_src EXCLUDE REGEX ".*aes_tab.c")
list(FILTER libtomcrypt_src EXCLUDE REGEX ".*whirltab.c")
list(FILTER libtomcrypt_src EXCLUDE REGEX ".*sober128tab.c")

add_library                 (libtomcrypt ${libtomcrypt_src})
target_compile_definitions  (libtomcrypt PRIVATE LTC_NO_ROLC LTC_SOURCE)
project_group               (libtomcrypt Extern)


########################################
# LIBRARY decNumber
########################################

file(GLOB_RECURSE decNumber_src "extern/decNumber/*.c" "extern/decNumber/*.h")
list(FILTER decNumber_src EXCLUDE REGEX ".*decBasic.c")
list(FILTER decNumber_src EXCLUDE REGEX ".*decCommon.c")

add_library                 (decNumber ${decNumber_src})
project_group               (decNumber Extern)


########################################
# EXECUTABLE btyacc
########################################

file(GLOB btyacc_src "extern/btyacc/*.c" "extern/btyacc/*.h")

if (NOT CMAKE_CROSSCOMPILING)

add_executable          (btyacc ${btyacc_src})
project_group           (btyacc Extern)
set_output_directory    (btyacc . CURRENT_DIR)

endif() # if (NOT CMAKE_CROSSCOMPILING)

########################################
# EXECUTABLE cloop
########################################

file(GLOB cloop_src "extern/cloop/src/cloop/*.cpp" "extern/cloop/src/cloop/*.h")

add_executable          (cloop ${cloop_src})
project_group           (cloop Extern)

########################################
# subdirectories
########################################

add_subdirectory("examples")
add_subdirectory("src")

################################################################################

=== src/CMakeLists.txt ===
#
# firebird (trunk)
#
#  This file has following organization:
#  1. preprocess
#  2. custom build steps (file generators)
#  3. libraries
#  4. shared libraries
#  5. executables
#  6. subdirectories
#  7. copy other files to output dir (docs, includes, ...)
#

include(SourceGroups)

set_generated_directory()

################################################################################
#
# PREPROCESS
#
################################################################################

########################################
# PREPROCESS epp boot and master files
########################################

set(epp_boot_internal_files
    burp/backup.epp
    burp/restore.epp
    burp/OdsDetection.epp
)
set(epp_boot_ocxx_files
    isql/extract.epp
    isql/isql.epp
    isql/show.epp
)
set(epp_boot_files
    alice/alice_meta.epp
    gpre/std/gpre_meta.epp
    utilities/stats.epp
    yvalve/array.epp
    yvalve/blob.epp
    utilities/gstat/dba.epp
)
set(epp_boot_gds_files
    dsql/metd.epp
    dsql/DdlNodes.epp
    dsql/PackageNodes.epp
    jrd/dfw.epp
    jrd/dpm.epp
    jrd/dyn_util.epp
    jrd/fun.epp
    jrd/grant.epp
    jrd/ini.epp
    jrd/met.epp
    jrd/scl.epp
    jrd/Function.epp
)
set(epp_master_files
    auth/SecurityDatabase/LegacyManagement.epp
    msgs/build_file.epp
    misc/codes.epp
    qli/help.epp
    qli/meta.epp
    qli/proc.epp
    qli/show.epp
)

if (NOT CMAKE_CROSSCOMPILING)

epp_process(boot    epp_boot_internal_files ${GPRE_BOOT_CMD} -lang_internal -n -ids -ocxx -m)
epp_process(boot    epp_boot_ocxx_files     ${GPRE_BOOT_CMD} -lang_internal -n -ids -ocxx)
epp_process(boot    epp_boot_files          ${GPRE_BOOT_CMD} -n -m)
epp_process(boot    epp_boot_gds_files      ${GPRE_BOOT_CMD} -n -ids -gds_cxx)

epp_process(master  epp_boot_internal_files ${BOOT_GPRE_CMD} -n -m -ids -ocxx -m)
epp_process(master  epp_boot_ocxx_files     ${BOOT_GPRE_CMD} -n -ids -ocxx)
epp_process(master  epp_boot_files          ${BOOT_GPRE_CMD} -n -m)
epp_process(master  epp_boot_gds_files      ${BOOT_GPRE_CMD} -n -ids -gds_cxx)
epp_process(master  epp_master_files        ${BOOT_GPRE_CMD} -n -m)


################################################################################
#
# CUSTOM BUILD STEPS
#
################################################################################

########################################
# BUILD STEP databases
########################################

set(msgs_src
    ${CMAKE_CURRENT_SOURCE_DIR}/msgs/facilities2.sql
    ${CMAKE_CURRENT_SOURCE_DIR}/msgs/history2.sql
    ${CMAKE_CURRENT_SOURCE_DIR}/msgs/locales.sql
    ${CMAKE_CURRENT_SOURCE_DIR}/msgs/messages2.sql
    ${CMAKE_CURRENT_SOURCE_DIR}/msgs/msg.sql
    ${CMAKE_CURRENT_SOURCE_DIR}/msgs/sqlstates.sql
    ${CMAKE_CURRENT_SOURCE_DIR}/msgs/symbols2.sql
    ${CMAKE_CURRENT_SOURCE_DIR}/msgs/system_errors2.sql
    ${CMAKE_CURRENT_SOURCE_DIR}/msgs/transmsgs.de_DE2.sql
    ${CMAKE_CURRENT_SOURCE_DIR}/msgs/transmsgs.fr_FR2.sql
)
set(databases_src
    ${CMAKE_CURRENT_SOURCE_DIR}/dbs/security.sql
    ${msgs_src}
)
add_custom_command(
    OUTPUT security.fdb
    DEPENDS
        boot_isql
        boot_gfix
        ${CMAKE_CURRENT_SOURCE_DIR}/dbs/security.sql
    VERBATIM
    #
    COMMAND ${CMAKE_COMMAND} -E remove security.fdb
    COMMAND ${CMAKE_COMMAND} -E remove security_.fdb
    COMMAND ${CMAKE_COMMAND} -E echo "create database 'security_.fdb';" > create_db_security.sql
    COMMAND ${BOOT_ISQL_CMD} -q -i create_db_security.sql
    COMMAND ${BOOT_GFIX_CMD} -write async security_.fdb
    COMMAND ${BOOT_ISQL_CMD} -q security_.fdb -i ${CMAKE_CURRENT_SOURCE_DIR}/dbs/security.sql
    COMMAND ${CMAKE_COMMAND} -E copy_if_different security_.fdb security.fdb
    COMMAND ${BOOT_GFIX_CMD} -write sync security.fdb
)
add_custom_command(
    OUTPUT metadata.fdb
    DEPENDS
        boot_gbak
        ${CMAKE_SOURCE_DIR}/builds/misc/metadata.gbak
    #
    COMMAND ${CMAKE_COMMAND} -E remove metadata.fdb
    COMMAND ${CMAKE_COMMAND} -E remove metadata_.fdb
    COMMAND ${BOOT_GBAK_CMD} -r ${CMAKE_SOURCE_DIR}/builds/misc/metadata.gbak metadata_.fdb
    COMMAND ${CMAKE_COMMAND} -E copy_if_different metadata_.fdb metadata.fdb
)
add_custom_command(
    OUTPUT help.fdb
    DEPENDS
        boot_gbak
        metadata.fdb
        ${CMAKE_SOURCE_DIR}/builds/misc/help.gbak
    #
    COMMAND ${CMAKE_COMMAND} -E remove help.fdb
    COMMAND ${CMAKE_COMMAND} -E remove help_.fdb
    COMMAND ${BOOT_GBAK_CMD} -r ${CMAKE_SOURCE_DIR}/builds/misc/help.gbak help_.fdb
    COMMAND ${CMAKE_COMMAND} -E copy_if_different help_.fdb help.fdb
)
add_custom_target(databases
    DEPENDS
        boot_engine
        help.fdb
        metadata.fdb
        security.fdb
    SOURCES
        ${databases_src}
)
add_dependencies_cc(databases msg_fdb)
project_group(databases "Boot/Custom build steps")


########################################
# BUILD STEP messages
########################################

add_custom_command(
    OUTPUT firebird.msg
    DEPENDS
        build_msg
        msg_fdb
    #
    COMMAND ${CMAKE_COMMAND} -E remove firebird.msg
    COMMAND ${BUILD_MSG_CMD} -D msg.fdb -P ${CMAKE_CURRENT_BINARY_DIR}/ -F firebird.msg -L all
    COMMAND ${BUILD_MSG_CMD} -D msg.fdb -P ${CMAKE_CURRENT_BINARY_DIR}/ -F firebird.msg
    COMMAND ${CMAKE_COMMAND} -E copy_if_different firebird.msg ${output_dir}/firebird.msg
)
add_custom_command(
    OUTPUT codes_headers.dummy
    DEPENDS
        codes
        msg_fdb
    COMMENT ""
    #
    COMMAND ${CMAKE_COMMAND} -E echo "" > codes_headers.dummy
    COMMAND ${CMAKE_COMMAND} -E echo Building codes header...
    COMMAND ${CODES_CMD} ${CMAKE_CURRENT_SOURCE_DIR}/include/gen ${CMAKE_SOURCE_DIR}/lang_helpers
)
add_custom_target(messages ALL DEPENDS firebird.msg codes_headers.dummy)
project_group(messages "Boot/Custom build steps")


########################################
# BUILD STEP msg_fdb
########################################

set(isql_exec_msg ${BOOT_ISQL_CMD} -q msg_.fdb -i ${CMAKE_CURRENT_SOURCE_DIR}/msgs)

add_custom_command(
    OUTPUT msg.fdb
    VERBATIM
    DEPENDS
        boot_isql
        boot_gfix
        ${msgs_src}
    #
    COMMAND ${CMAKE_COMMAND} -E remove msg.fdb
    COMMAND ${CMAKE_COMMAND} -E remove msg_.fdb
    COMMAND ${CMAKE_COMMAND} -E echo "create database 'msg_.fdb';" > create_db_msg.sql
    COMMAND ${BOOT_ISQL_CMD} -q -i create_db_msg.sql
    COMMAND ${BOOT_GFIX_CMD} -write async msg_.fdb
    COMMAND ${isql_exec_msg}/msg.sql
    #
    COMMAND echo loading facilities
    COMMAND ${isql_exec_msg}/facilities2.sql
    COMMAND echo loading sql states
    COMMAND ${isql_exec_msg}/sqlstates.sql
    COMMAND echo loading locales
    COMMAND ${isql_exec_msg}/locales.sql
    COMMAND echo loading history
    COMMAND ${isql_exec_msg}/history2.sql
    COMMAND echo loading messages
    COMMAND ${isql_exec_msg}/messages2.sql
    COMMAND echo loading symbols
    COMMAND ${isql_exec_msg}/symbols2.sql
    COMMAND echo loading system errors
    COMMAND ${isql_exec_msg}/system_errors2.sql
    COMMAND echo loading French translation
    COMMAND ${isql_exec_msg}/transmsgs.fr_FR2.sql
    COMMAND echo loading German translation
    COMMAND ${isql_exec_msg}/transmsgs.de_DE2.sql
    #
    COMMAND ${CMAKE_COMMAND} -E copy_if_different msg_.fdb msg.fdb
)
add_custom_target(msg_fdb
    DEPENDS
        boot_engine
        msg.fdb
)
project_group(msg_fdb "Boot/Custom build steps")


########################################
# BUILD_STEP parse
########################################

set(parse_src
    ${CMAKE_CURRENT_SOURCE_DIR}/dsql/parse.y
    ${CMAKE_CURRENT_SOURCE_DIR}/dsql/btyacc_fb.ske
)
add_custom_command(
    OUTPUT y_tab.h y_tab.c
    DEPENDS
        btyacc
        ${parse_src}
    COMMAND sed -n "/%type .*/p" ${CMAKE_CURRENT_SOURCE_DIR}/dsql/parse.y > types.y
    COMMAND sed "s/%type .*//" ${CMAKE_CURRENT_SOURCE_DIR}/dsql/parse.y > y.y
    COMMAND btyacc -l -d -S ${CMAKE_CURRENT_SOURCE_DIR}/dsql/btyacc_fb.ske y.y

    COMMAND sed -i "s/#define \\([A-Z].*\\)/#define TOK_\\1/g" y_tab.h
    COMMAND sed -i "s/#define TOK_YY\\(.*\\)/#define YY\\1/g" y_tab.h

    COMMAND ${CMAKE_COMMAND} -E copy_if_different y_tab.h include/gen/parse.h
    COMMAND ${CMAKE_COMMAND} -E copy_if_different y_tab.c dsql/parse.cpp
    COMMENT "Generating parse.cpp, parse.h"
    VERBATIM
)
add_custom_target(parse
    DEPENDS y_tab.h y_tab.c
    SOURCES ${parse_src} y_tab.h y_tab.c
)
project_group(parse "Boot/Custom build steps")
set_source_files_properties(dsql/parse.cpp include/gen/parse.h PROPERTIES GENERATED TRUE)


########################################
# BUILD_STEP UpdateCloopInterfaces
########################################

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/include/firebird/IdlFbInterfaces.h
    DEPENDS
        cloop
        ${CMAKE_CURRENT_SOURCE_DIR}/include/firebird/FirebirdInterface.idl
    COMMAND cloop
            ${CMAKE_CURRENT_SOURCE_DIR}/include/firebird/FirebirdInterface.idl
            c++
            ${CMAKE_CURRENT_SOURCE_DIR}/include/firebird/IdlFbInterfaces.h
            IDL_FB_INTERFACES_H Firebird I
    COMMENT "Updating cloop interfaces..."
)
add_custom_target(UpdateCloopInterfaces
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/include/firebird/IdlFbInterfaces.h
    SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/include/firebird/FirebirdInterface.idl
)
project_group(UpdateCloopInterfaces "Boot/Custom build steps")

endif() # if (NOT CMAKE_CROSSCOMPILING)


################################################################################
#
# LIBRARIES
#
################################################################################

########################################
# LIBRARY boot_alice
########################################

file(GLOB alice_src "alice/*.cpp" "alice/*.h")

set(alice_generated_src
    alice/alice_meta.epp
)
add_epp_suffix(alice_generated_src boot)
add_epp_suffix(alice_generated_src master)

if (NOT CMAKE_CROSSCOMPILING)

add_library                 (boot_alice ${alice_src} ${alice_generated_src_boot})
project_group               (boot_alice Boot)

endif() # if (NOT CMAKE_CROSSCOMPILING)


########################################
# LIBRARY alice
########################################

add_library                 (alice ${alice_src} ${alice_generated_src_master})


########################################
# LIBRARY boot_burp
########################################

file(GLOB burp_src "burp/*.cpp" "burp/*.h")

set(burp_generated_src
    burp/backup.epp
    burp/OdsDetection.epp
    burp/restore.epp
)
add_epp_suffix(burp_generated_src boot)
add_epp_suffix(burp_generated_src master)

if (NOT CMAKE_CROSSCOMPILING)

add_library                 (boot_burp ${burp_src} ${burp_generated_src_boot})
project_group               (boot_burp Boot)

endif() # if (NOT CMAKE_CROSSCOMPILING)


########################################
# LIBRARY burp
########################################

add_library                 (burp ${burp_src} ${burp_generated_src_master})


########################################
# LIBRARY common
########################################

file(GLOB common_src "common/*.cpp" "common/classes/*.cpp" "common/config/*.cpp" "common/os/${OS_DIR}/*.cpp" "common/sha2/*.cpp")
file(GLOB_RECURSE common_include "common/*.h")

if (APPLE)
    file(GLOB common_os_src "common/os/posix/*.cpp")
    list(REMOVE_ITEM common_os_src ${CMAKE_CURRENT_BINARY_DIR}/common/os/posix/mod_loader.cpp)
endif()

add_library                 (common ${common_src} ${common_os_src} ${common_include})
target_link_libraries       (common ${LIB_mpr} libtommath libtomcrypt decNumber)
add_dependencies_cc         (common UpdateCloopInterfaces)
if (UNIX)
target_link_libraries       (common dl)
endif()


################################################################################
#
# SHARED LIBRARIES
#
################################################################################

########################################
# SHARED LIBRARY boot_yvalve
########################################

=== extern/btyacc/Makefile ===
#
# Makefile for BtYacc.
#

VERSION       = 3-0

DEST	      = .

HDRS	      = defs.h mstring.h

# Keep this as simple as possible. It's desirable that btyacc be portable
# across all of our supported compilers/platforms.

# Vanilla CFLAGS
CFLAGS=

# No LDFLAGS
#LDFLAGS=

LIBS=

# For GNU environment, gmake will set $CC to gcc
# Other environments will have different values, maybe no GNU installed!
#CC	      = gcc

MAKEFILE      = Makefile

OBJS	      = closure.o error.o lalr.o lr0.o main.o mkpar.o output.o	\
		mstring.o reader.o readskel.o skeleton.o symtab.o verbose.o warshall.o

PRINT	      = pr -f -l88

PROGRAM	      = btyacc

SRCS	      = closure.c error.c lalr.c lr0.c main.c mkpar.c output.c	\
		mstring.c reader.c readskel.c skeleton.c symtab.c verbose.c warshall.c

OTHERS	      = README README.BYACC \
		Makefile btyaccpa.ske push.skel empty.y skel2c manpage makefile.dos \
		skeleton.c

all:		$(PROGRAM)

$(PROGRAM):     $(OBJS) $(LIBS)
		$(CC) $(LDFLAGS) -o $(PROGRAM) $(OBJS) $(LIBS)

clean:;		rm -f $(OBJS)

clobber:;	rm -f $(OBJS) $(PROGRAM)

distclean:;	rm -f $(OBJS) $(PROGRAM) *.zip *.gz

depend:;	mkmf -f $(MAKEFILE) PROGRAM=$(PROGRAM) DEST=$(DEST)

index:;		ctags -wx $(HDRS) $(SRCS)

install:	$(PROGRAM)
		cp $(PROGRAM).exe /bin

oldinstall:	$(PROGRAM)
		@echo Installing $(PROGRAM) in $(DEST)
		install -s $(PROGRAM) $(DEST)

listing:;	$(PRINT) Makefile $(HDRS) $(SRCS) | lpr

lint:;		lint $(SRCS)

program:        $(PROGRAM)

tags:           $(HDRS) $(SRCS)
		ctags $(HDRS) $(SRCS)

dist:		tar zip

tar:
		rm -f btyacc.tar btyacc.tar.gz
		tar cvf btyacc.tar $(OTHERS) $(SRCS) $(HDRS) test/*.y
		gzip -9 btyacc.tar
		mv btyacc.tar.gz btyacc-$(VERSION).tar.gz

zip:
		zip btyacc.zip $(OTHERS) $(SRCS) $(HDRS) test/*.y
		mv btyacc.zip btyacc-$(VERSION).zip

# skeleton.c now stored in CVS, not generated by build
#skeleton.c: btyaccpa.ske skel2c
#		awk -f skel2c btyaccpa.ske >skeleton.c

etags TAGS:
		etags *.c *.h

###
closure.o: defs.h
error.o: defs.h
lalr.o: defs.h
lr0.o: defs.h
main.o: defs.h
mkpar.o: defs.h
mstring.o: mstring.h
output.o: defs.h
reader.o: defs.h mstring.h
skeleton.o: defs.h
symtab.o: defs.h
verbose.o: defs.h
warshall.o: defs.h

=== src/remote/CMakeLists.txt ===
include(SourceGroups)

###############################################################################
# LIBRARY remote
###############################################################################

set(remote_src
    merge.cpp
    parser.cpp
    protocol.cpp
    remote.cpp
    inet.cpp

    ../auth/SecureRemotePassword/srp.cpp
    ../auth/SecureRemotePassword/srp.h
    ../auth/SecureRemotePassword/Message.h
    ../auth/trusted/AuthSspi.cpp
)
add_src_win32(remote_src
    os/win32/wnet.cpp
    os/win32/wnet_proto.h
    os/win32/xnet.cpp
    os/win32/xnet.h
    os/win32/xnet_proto.h
)
file(GLOB remote_include "*.h")

add_library             (remote ${remote_src} ${remote_include})
add_dependencies_cc     (remote UpdateCloopInterfaces)


###############################################################################
# EXECUTABLE fbserver
###############################################################################

set(fbserver_src
    ../auth/SecureRemotePassword/server/SrpServer.cpp
    ../auth/SecureRemotePassword/server/SrpServer.h
)
add_src_win32(fbserver_src
    server/os/win32/chop.cpp
    server/os/win32/cntl.cpp
    server/os/win32/property.cpp
    server/os/win32/window.cpp
    server/os/win32/srvr_w32.cpp
    server/os/win32/server.ico
    server/os/win32/caution.ico
    server/os/win32/window.rc
    server/ReplServer.cpp
    server/server.cpp
)
add_src_unix(fbserver_src
    ../auth/SecureRemotePassword/srp.cpp
    server/os/posix/inet_server.cpp
    server/server.cpp

    inet.cpp
    merge.cpp
    parser.cpp
    protocol.cpp
    remote.cpp
)

add_executable              (fbserver WIN32 ${fbserver_src})
target_link_libraries       (fbserver remote common yvalve engine_common ${LIB_comctl32})
set_target_properties       (fbserver PROPERTIES OUTPUT_NAME firebird)

=== debian/changelog ===
firebird4.0 (4.0.5.3140.ds6-17+deb13u1) trixie-security; urgency=medium

  * cherry pick fix for CVE-2025-54989 from upstream (Closes: #1111320)
  * cherry pick fix for CVE-2025-24975 from upstream (Closes: #1111322)
  * switch debian-branch to debian/trixie-security in gbp.conf

 -- Damyan Ivanov <dmn@debian.org>  Mon, 25 Aug 2025 13:51:42 +0000

firebird4.0 (4.0.5.3140.ds6-17) unstable; urgency=medium

  * Added po-debconf Catalan translation by poc senderi
    <pocsenderi@protonmail.com>
  * Adjust lintian overrides

 -- Damyan Ivanov <dmn@debian.org>  Sun, 23 Mar 2025 16:32:11 +0000

firebird4.0 (4.0.5.3140.ds6-16) unstable; urgency=medium

  [ Gioele Barabucci ]
  * d/control: Remove outdated debconf version constraint (Closes: #1096117)

 -- Damyan Ivanov <dmn@debian.org>  Mon, 17 Feb 2025 07:58:41 +0000

firebird4.0 (4.0.5.3140.ds6-15) unstable; urgency=medium

  * add Breaks: libreoffice-sdbc-firebird (<< 4:24.8.4-2~) (Closes: #1094284)

 -- Damyan Ivanov <dmn@debian.org>  Sat, 08 Feb 2025 11:43:58 +0000

firebird4.0 (4.0.5.3140.ds6-14) unstable; urgency=medium

  * fix init.d-style service management

 -- Damyan Ivanov <dmn@debian.org>  Fri, 07 Feb 2025 15:17:31 +0000

firebird4.0 (4.0.5.3140.ds6-13) unstable; urgency=medium

  * move RemoteServicePort from firebird.conf to a separate file, managed in
    postinst

 -- Damyan Ivanov <dmn@debian.org>  Wed, 05 Feb 2025 14:54:25 +0000

firebird4.0 (4.0.5.3140.ds6-12) unstable; urgency=medium

  * functions.sh: fix shell quoting, also in generated SYSDBA.password
  * -server.postinst: create 'firebird' user only if it doesn't exists
  * install /var/lib/firebird in firebird4.0-server-core
    Closes: #1094221

 -- Damyan Ivanov <dmn@debian.org>  Sun, 26 Jan 2025 16:49:16 +0000

firebird4.0 (4.0.5.3140.ds6-11) unstable; urgency=medium

  * Upload to unstable

 -- Damyan Ivanov <dmn@debian.org>  Sat, 25 Jan 2025 15:24:35 +0000

firebird4.0 (4.0.5.3140.ds6-10) experimental; urgency=medium

  * bump 3.0 dependencies' version above what's in unstable

 -- Damyan Ivanov <dmn@debian.org>  Thu, 16 Jan 2025 14:51:43 +0000

firebird4.0 (4.0.5.3140.ds6-9) experimental; urgency=medium

  * -common: drop Breaks: firebird3.0-common (Closes: #1093120)

 -- Damyan Ivanov <dmn@debian.org>  Wed, 15 Jan 2025 13:00:53 +0000

firebird4.0 (4.0.5.3140.ds6-8) experimental; urgency=medium

  * fix typo in Bulgarian PO translation
  * add ../system to -server.dirs
  * fix package name in SYSDBA.password comments
  * add a patch from upstream fixing thread initialization
  * bump 3.0 dependencies' version above what's in unstable

 -- Damyan Ivanov <dmn@debian.org>  Wed, 15 Jan 2025 09:16:41 +0000

firebird4.0 (4.0.5.3140.ds6-7) experimental; urgency=medium

  * rules: fix path to security.fdb

 -- Damyan Ivanov <dmn@debian.org>  Mon, 13 Jan 2025 14:57:57 +0000

firebird4.0 (4.0.5.3140.ds6-6) experimental; urgency=medium

  * fix architecture-dependent builds (--arch-any --no-arch-all)

 -- Damyan Ivanov <dmn@debian.org>  Fri, 10 Jan 2025 15:09:55 +0000

firebird4.0 (4.0.5.3140.ds6-5) experimental; urgency=medium

  * use dh_install* for populating package contents; add firebird/impl/*.h
    files
    (Closes: #1092490)
  * libibutil.lintian-overrides: use wildcards instead of sed patching

 -- Damyan Ivanov <dmn@debian.org>  Fri, 10 Jan 2025 11:54:23 +0000

firebird4.0 (4.0.5.3140.ds6-4) experimental; urgency=medium

  * Add a patch from Matthias Klose dropping -march=i586 -mtune=i686
    (Closes: #1092469)

 -- Damyan Ivanov <dmn@debian.org>  Wed, 08 Jan 2025 13:54:40 +0000

firebird4.0 (4.0.5.3140.ds6-3) experimental; urgency=medium

  * bump 3.0 dependencies' version above what's in unstable
  * properly import mips64el and loongarch support from upstream
  * update patch offsets
  * fix Bug-Debian URL
  * disable link-time optimizations (Closes: #1092468)

 -- Damyan Ivanov <dmn@debian.org>  Wed, 08 Jan 2025 11:10:37 +0000

firebird4.0 (4.0.5.3140.ds6-2) experimental; urgency=medium

  * patch in mips64 and loongarch support
  * refresh patches

 -- Damyan Ivanov <dmn@debian.org>  Thu, 02 Jan 2025 08:26:45 +0000

firebird4.0 (4.0.5.3140.ds6-1) experimental; urgency=medium

  * New upstream version 4.0.5.3140.ds6
  * update debian/copyright
  * refresh/rebase patches
  * bump 3.0 dependencies' version above what's in unstable

 -- Damyan Ivanov <dmn@debian.org>  Tue, 31 Dec 2024 08:43:14 +0000

firebird4.0 (4.0.4.3010.ds6-5) experimental; urgency=medium

  * replace hard-coded paths with pkgconf queries
    helps /usr merge transition, see #1073615 (in firebird 3.0)
  * bump FB#_MULTI_VER to make firebird-utils conflict/replace unstable
    versions (Closes: #1074298)

 -- Damyan Ivanov <dmn@debian.org>  Sun, 30 Jun 2024 13:34:35 +0000

firebird4.0 (4.0.4.3010.ds6-4) experimental; urgency=medium

  * cherry-pick -std=c++17 from upstream.
    Fixes build with libre2-dev 20240501 which requires at least c++-14
    (Closes: #1071759)
  * Bump Standards-Version to 4.7.0 (no changes necessary)

 -- Damyan Ivanov <dmn@debian.org>  Sat, 25 May 2024 12:30:54 +0000

firebird4.0 (4.0.4.3010.ds6-3) experimental; urgency=medium

  * replace build-dependency on pkg-config with pkgconf
  * fix arch=all build Closes: #1071133

 -- Damyan Ivanov <dmn@debian.org>  Sun, 19 May 2024 12:25:16 +0000

firebird4.0 (4.0.4.3010.ds6-2) experimental; urgency=medium

  * bump again 3.0 dependencies' version

 -- Damyan Ivanov <dmn@debian.org>  Fri, 05 Apr 2024 07:56:22 +0000

firebird4.0 (4.0.4.3010.ds6-1) experimental; urgency=medium

  * bump 3.0 dependencies' version above what's in unstable
    Closes: #1040321
    also, put the version in a variable for easier management
  * libfbclient2: break 3.0 server packages not supporting multi-version
  * drop dependency on lsb-base again (mismerged)
  * New upstream version 4.0.4.3010.ds6
  * update tzdata copyright years, provide verification script
  * drop system-re2.patch, merged upstream
  * refresh patches to apply cleanly



=== debian/control ===
Source: firebird4.0
Section: database
Priority: optional
Maintainer: Damyan Ivanov <dmn@debian.org>
Build-Depends:
 autoconf,
 automake,
 debhelper-compat (= 13),
 gawk,
 libabsl-dev,
 libboost-dev,
 libedit-dev,
 libicu-dev,
 libre2-dev,
 libtomcrypt-dev,
 libtommath-dev,
 libtool,
 pkgconf,
 po-debconf,
 recode,
 rename,
 systemd-dev,
 unzip,
 zlib1g-dev,
Build-Conflicts:
 autoconf2.13,
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/firebird-team/firebird4.0.git
Vcs-Browser: https://salsa.debian.org/firebird-team/firebird4.0
Homepage: https://firebirdsql.org/
Rules-Requires-Root: no

Package: firebird-dev
Section: libdevel
Architecture: any
Depends:
 firebird4.0-common-doc (= ${source:Version}),
 libfbclient2 (>= ${source:Version}),
 libib-util (>= ${source:Version}),
 ${misc:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Suggests:
 firebird4.0-examples,
Description: Development files for Firebird
 C header files for Firebird, useful if one compiles programs that use the
 Firebird client to work with Firebird databases.
 .
 See firebird4.0-server package for more information about Firebird.

Package: firebird4.0-common
Architecture: all
Multi-Arch: foreign
Depends:
 firebird4.0-common-doc (= ${source:Version}),
 perl,
 ${misc:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: common files for firebird 4.0 server, client and utilities
 Common files for the Firebird server, client and user utilities.
 .
 These include the support scripts as well as configuration files in
 /etc/firebird/4.0.

Package: firebird4.0-common-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: copyright, licensing and changelogs of firebird4.0
 Copyright, licensing information and upstream changelog of firebird4.0.
 .
 Due to the size of the upstream change log and copyright/licensing summary,
 keeping them in a separate package saves space on mirrors and when installing
 firebird4.0 packages.

Package: firebird4.0-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 firebird4.0-common-doc (= ${source:Version}),
 ${misc:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: Documentation files for firebird database version 4.0
 Various documents for firebird 4.0. These include the release notes, what's
 new in firebird 4.0, quick start guide, upgrade guide, list of ISQL
 enhancements etc.

Package: firebird4.0-examples
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 firebird4.0-common-doc (= ${source:Version}),
 ${misc:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Recommends:
 firebird4.0-dev,
Description: Examples for Firebird database
 The examples included in this package are provided as samples and are also
 used by Firebird's testing suite (TCS). The examples are in the form
 of .h, .c, .e, .fdb and .gbk files.
 .
 See firebird4.0-server package for more information about Firebird.

Package: firebird4.0-server
Architecture: any
Depends:
 adduser,
 firebird4.0-common (= ${source:Version}),
 firebird4.0-common-doc (= ${source:Version}),
 firebird4.0-server-core (= ${binary:Version}),
 firebird4.0-utils (= ${binary:Version}),
 firebird-utils,
 libfbclient2 (>= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Recommends:
 libib-util,
Suggests:
 firebird4.0-doc,
Description: Firebird Server - an RDBMS based on InterBase 6.0 code
 Firebird is a relational database offering many ANSI SQL-99 features that
 runs on Linux, Windows, and a variety of Unix platforms. Firebird offers
 excellent concurrency, high performance, and powerful language support
 for stored procedures and triggers. It has been used on production systems
 under a variety of names since 1981.
 .
 This package contains the server binary as well as its configuration files.
 The default mode of operation is the so called "super", which is a
 single-threaded server process with shared database cache between
 connections. The two other operation modes -- "classic" (separate
 process/cache for each connection) and "superclassic" (separate thread/cache
 for each connection) are also available via configuration options.

Package: firebird4.0-server-core
Architecture: any
Multi-Arch: same
Depends:
 firebird4.0-common (= ${source:Version}),
 firebird4.0-common-doc (= ${source:Version}),
 ${icu:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Recommends:
 firebird4.0-utils,
Suggests:
 firebird4.0-server,
Enhances:
 libfbclient2,
Description: Firebird engine core
 Firebird database engine and support libraries. This package is required for
 embedded (serverless) access to local databases with the tools packaged in
 firebird4.0-utils or other binaries linked to the firebird client library,
 libfbclient2.
 .
 The rest of the binaries needed for running a full-featured,
 remotely-accessible Firebird server are in the firebird4.0-server package.

Package: firebird-utils
Architecture: all
Depends:
 firebird4.0-common-doc (= ${source:Version}),
 firebird4.0-utils | firebird3.0-utils (>= ${fb3:multi-ver}),
 ${misc:Depends},
Replaces:
 firebird3.0-utils (<< ${fb3:multi-ver}),
 firebird3.0-server (<< ${fb3:multi-ver}),
Breaks:
 firebird3.0-utils (<< ${fb3:multi-ver}),
 firebird3.0-server (<< ${fb3:multi-ver}),
Recommends:
 firebird4.0-server-core,
Suggests:
 firebird4.0-doc,
 firebird4.0-server,
Description: Firebird command line utilities wrapper
 firebird-utils contains a wrapper script which allows running specific
 version of firebird utilities like gbak or isql-fb. If no version is
 specified, the latest available is used.

Package: firebird4.0-utils
Architecture: any
Depends:
 firebird-utils,
 firebird4.0-common (= ${source:Version}),
 firebird4.0-common-doc (= ${source:Version}),
 libfbclient2 (>= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Recommends:
 firebird4.0-server-core,
Suggests:
 firebird4.0-doc,
 firebird4.0-server,
Description: Firebird command line utilities
 This package contains the utilities for managing Firebird databases:
  * isql-fb -- interactive console (original name isql)
  * gbak -- backup and restore databases
  * gfix -- check and repair databases
  * gsec -- manage users and roles
  * fbstat -- analyze databases (original name gstat)
  * nbackup -- incremental backup and file-level copy
  * gpre -- preprocess sources with embedded SQL

Package: libfbclient2
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 firebird4.0-common (= ${source:Version}),
 firebird4.0-common-doc (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks: firebird3.0-server (<< ${fb3:multi-ver}),
 libreoffice-sdbc-firebird (<< 4:24.8.4-2~),
Pre-Depends:
 ${misc:Pre-Depends},
Description: Firebird client library
 Client library for connecting to the Firebird server. It can also be used for
 direct (embedded) database access.
 .
 See firebird4.0-server package for more information about Firebird.

Package: libib-util
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 firebird4.0-common-doc (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: Firebird UDF support library
 Contains utility functions used by Firebird User-Defined Functions (UDF) for
 memory management etc.
 .
 See firebird4.0-server package for more information about Firebird.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

FB_MAJOR:= $(shell awk '/FB_MAJOR_VER/ { v=$$3; gsub("\"", "", v); print v}' < src/jrd/build_no.h )
export FB_MAJOR
FB_MINOR:= $(shell awk '/FB_MINOR_VER/ { v=$$3; gsub("\"", "", v); print v}' < src/jrd/build_no.h )
FB_REV	:= $(shell awk '/FB_REV_NO/    { v=$$3; gsub("\"", "", v); print v}' < src/jrd/build_no.h )
FB_VER	:= $(FB_MAJOR).$(FB_MINOR)
export FB_VER
FB_FULL_VER:= $(FB_VER).$(FB_REV)
export FB_FULL_VER
FB_VER_NO_DOTS := $(FB_MAJOR)$(FB_MINOR)
export FB_VER_NO_DOTS

FB3_MULTI_VER="3.0.12.ds7-7+exp~"

include /usr/share/dpkg/pkg-info.mk
SOURCE_DATE := $(shell date -d@$(SOURCE_DATE_EPOCH) -u +"%Y-%m-%d")

CLIENT_SOVER := 2
export CLIENT_SOVER
UTIL_SOVER :=

ifndef FB_MAJOR
$(error FB_MAJOR not defined)
else ifndef FB_MINOR
$(error FB_MINOR not defined)
else ifndef FB_REV
$(error FB_REV not defined)
else ifndef FB_VER
$(error FB_VER not defined)
else ifndef FB_FULL_VER
$(error FB_FULL_VER not defined)
else ifndef CLIENT_SOVER
$(error CLIENT_SOVER not defined)
endif

-include /usr/share/dpkg/buildtools.mk
PKG_CONFIG ?= pkg-config
# Use the following lines to set the compiler if
# the default Debian one can't be used (or you want to try
# the bleeding edge)
#export CC=gcc-5
#export CXX=g++-5
#export CPP=cpp-5
#export CXXPP=cpp-5


export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
   NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
	confflags += --build $(DEB_HOST_GNU_TYPE)
else
	confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH_OS), linux)
	confflags += --enable-raw-devices
else
	confflags += --disable-raw-devices
endif

DOC := /usr/share/doc/firebird${FB_VER}-common-doc
ULFB := /usr/lib/${DEB_HOST_MULTIARCH}/firebird/${FB_VER}
USFB := /usr/share/firebird/${FB_VER}
VAR := /var/lib/firebird/${FB_VER}
RUN := /run/firebird${FB_VER}

DEB_BUILD_MAINT_OPTIONS := hardening=+bindnow optimize=-lto
DEB_CXXFLAGS_MAINT_STRIP := -O2
DEB_CXXFLAGS_MAINT_APPEND := -DUCHAR_TYPE=uint16_t -fno-lifetime-dse -fno-strict-aliasing -O3
DEB_CFLAGS_MAINT_STRIP := -O2
DEB_CFLAGS_MAINT_APPEND := -fno-strict-aliasing -O3

include /usr/share/dpkg/buildflags.mk

confflags += --disable-rpath --with-gpre-cobol \
	     --enable-regen-codes \
	     --with-system-re2 \
	     --with-system-editline --prefix=${ULFB} --with-fbsbin=/usr/sbin \
	     --with-fblib=/usr/lib/${DEB_HOST_MULTIARCH} \
	     --with-fbconf=${ULFB} --with-fbdoc=${DOC} \
	     --with-fbudf=${ULFB}/UDF --with-fbsample=${DOC}/examples \
	     --with-fbsample-db=${DOC}/examples/empbuild \
	     --with-fbhelp=${VAR}/system --with-fbintl=${ULFB}/intl \
	     --with-fbmisc=${ULFB}/misc --with-fbsecure-db=${VAR}/system \
	     --with-fblog=/var/log/firebird --with-fbglock=${RUN} \
	     --with-fblogfilename=firebird$(FB_VER).log \
	     --with-fbplugins=${ULFB}/plugins \
	     --with-fbmsg=${ULFB}

# see #575564
export FIREBIRD_LOCK := $(CURDIR)/debian/tmp-lock

# Packaging is split into several packages:
# * firebirdVV-server (incl libengineXX)
# * libfbclient2
# * libib-util
# * firebirdVV-utils
# * firebirdVV-common (common parts to client and utils)
# * firebirdVV-common-doc (big copyright and changelog in one place)
# * firebirdVV-doc
# * firebirdVV-examples
# * firebird-dev

override_dh_autoreconf:
	mkdir -p builds/make.new/config
	dh_autoreconf

override_dh_auto_configure:
	dh_auto_configure -- $(confflags)

ifneq (,$(filter nodoc,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
    MANUALS_BASE_USR :=
    MANUALS_BASE_SYS :=
else
    MANUALS_BASE_USR := isql-fb gbak gfix gpre gsec fbstat nbackup \
                        fbsvcmgr fbtracemgr fb_lock_print fb_config \
			fb_wrapper
    MANUALS_BASE_SYS := fbguard firebird
endif
MANUALS := $(addprefix debian/man/,$(addsuffix .1.gz,$(MANUALS_BASE_USR))) \
           $(addprefix debian/man/,$(addsuffix .8.gz,$(MANUALS_BASE_SYS)))

%.1 : %.pod
	pod2man -c "Firebird documentation" --release "Firebird $(FB_VER)"  $< > $@
%.8 : %.pod
	pod2man -c "Firebird documentation" --release "Firebird $(FB_VER)"  --section 8 $< > $@

%.1.gz : %.1
	gzip -n -9 < $< > $@

%.8.gz : %.8
	gzip -n -9 < $< > $@

FB_IMG := debian/firebird-image

ODS_VER=$(shell grep -E '^const \S+ ODS_CURRENT\b' src/jrd/ods.h | sed 's/.*ODS_CURRENT//; s/\;.*//')

override_dh_auto_build:
	$(MAKE) -f debian/rules $(NJOBS) $(MANUALS)
	[ -d $(FIREBIRD_TMP) ] || mkdir $(FIREBIRD_TMP)
	rm -rf $(FB_IMG)
	dh_auto_build -- QUIET=1

	#fakeroot $(MAKE) -C gen -f Makefile.install buildRoot
	#mv ./gen/buildroot ./debian/firebird-build
	cp -a ./gen/Release/firebird $(FB_IMG)
	cp -a src/include/gen $(FB_IMG)/include-gen

	sed -i -e's,-I$$fb_incdir,,'  $(FB_IMG)/bin/fb_config
	sed -i -e's,-L$$fb_libdir ,,' $(FB_IMG)/bin/fb_config

	sh $(FB_IMG)/bin/fb_config --cflags
	sh $(FB_IMG)/bin/fb_config --libs

	# renamed utilities
	cp -a $(FB_IMG)/bin/gstat $(FB_IMG)/bin/fbstat
	cp -a $(FB_IMG)/bin/isql  $(FB_IMG)/bin/isql-fb

	sed -i -e '/^#RemoteBindAddress/ a RemoteBindAddress = localhost' "$(FB_IMG)/firebird.conf"
	sed -i -e 's|^#SecurityDatabase.*|SecurityDatabase = /var/lib/firebird/$(FB_VER)/system/security$(FB_MAJOR).fdb|' "$(FB_IMG)/firebird.conf"
	sed -i -e 's|^#Providers.*|Providers = Remote,Engine$(ODS_VER),Loopback|' "$(FB_IMG)/firebird.conf"
	sed -i -e '/^#RemoteServicePort/ {' -e 'G' -e 'a # managed by debian package scripts' -e 'a include service-port.conf' -e '}' "$(FB_IMG)/firebird.conf"
	touch "$(FB_IMG)/service-port.conf"

	sed -i -e 's,$$(this),$$(root)/intl,' "$(FB_IMG)/intl/fbintl.conf"

	rm -r "$(FB_IMG)/examples/empbuild"
	debian/gen-employee-sql > "$(FB_IMG)/examples/employee.sql"

	cp debian/firebird4.0-examples.README.Debian "$(FB_IMG)/examples/README.Debian"

	debian/gen-xbin-wrappers

	echo "Built image contents"
	cd $(FB_IMG) && ls -lR

override_dh_auto_test:
	FIREBIRD=$(CURDIR)/debian/firebird-image debian/postbuild-tests

override_dh_clean:
	dh_clean
	
	rm -f $(MANUALS)
	
	debconf-updatepo
	
	@echo FB_MAJOR = $(FB_MAJOR)
	@echo FB_MINOR = $(FB_MINOR)
	@echo FB_REV   = $(FB_REV)
	@echo FB_VER   = $(FB_VER)
	@echo FB_FULL_VER = $(FB_FULL_VER)
	@echo CLIENT_SOVER= $(CLIENT_SOVER)
	@echo UTIL_SOVER= $(UTIL_SOVER)

override_dh_auto_install:
	true

override_dh_install:
	dh_install --sourcedir=debian/firebird-image

override_dh_installsystemd:
	sed -e "s/\$${FB_VER}/$(FB_VER)/g" < debian/systemd-services.sed.in > debian/systemd-services.sed
	sed -f debian/systemd-services.sed < gen/install/misc/firebird.service > debian/firebird$(FB_VER)-server.firebird$(FB_VER).service

	dh_installsystemd --name firebird$(FB_VER)

override_dh_installtmpfiles:
	dh_installtmpfiles --name firebird$(FB_VER)

ICU_VER := $(shell $(PKG_CONFIG) icu-i18n --modversion|sed 's/[^0-9]*\([0-9]\+\).*/\1/')
ifeq ($(ICU_VER),)
    $(error Unable to determine ICU version)
endif

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG.md -p firebird$(FB_VER)-common-doc
override_dh_installdocs-indep:
	dh_installdocs -p firebird$(FB_VER)-common-doc --doc-main-package=firebird$(FB_VER)-common-doc
	dh_installdocs -Xchangelog -Xcopyright -X license/IDPL.txt -p firebird$(FB_VER)-doc
	recode windows-1252..utf8 "debian/firebird$(FB_VER)-doc/usr/share/doc/firebird$(FB_VER)-doc/doc/ods11-index-structure.html"
	sed -i -e 's/windows-1252/UTF-8/' "debian/firebird$(FB_VER)-doc/usr/share/doc/firebird$(FB_VER)-doc/doc/ods11-index-structure.html"
override_dh_installdocs-arch:
	true
override_dh_installexamples:
	dh_installexamples -p firebird$(FB_VER)-examples --sourcedir=$(FB_IMG)
override_dh_installlogrotate:

=== debian/watch ===
# watch control file for uscan
# you can run the "uscan" command
# to check for upstream updates and more.
# Full-site-with-pattern  [Version  [Action]]

version=4
#opts="dversionmangle=s/(?:\.ds\d+)$//,uversionmangle=s/-\d+//;s/-(?=\D)/~/g,repacksuffix=.ds6" \
#  http://sf.net/firebird/[Ff]irebird-(4\.0\..*).tar.bz2
opts="dversionmangle=s/(?:\.ds\d+)$//,uversionmangle=s/-\d+//;s/-(?=\D)/~/g,repacksuffix=.ds6" \
  https://firebirdsql.org/en/firebird-4-0/ .*/[Ff]irebird-(4\.0\.\d+(?:\.\d+)?)(?:-0)?@ARCHIVE_EXT@
#opts="dversionmangle=s/(?:\.ds\d+)$//,uversionmangle=s/-\d+//;s/-(?=\D)/~/g,repacksuffix=.ds5" \
#  https://github.com/FirebirdSQL/firebird/releases .*/[Ff]irebird-(4\.0\.\d+(?:\.\d+)?)(?:-0)?@ARCHIVE_EXT@
